#!/usr/bin/env python3

from parsing.sysctl import Parsing
from vulnerabilities.system import system
from vulnerabilities.sysctl import sysctl


class Sysctl:
    def __init__(self):
        self._objects = dict()
        self._reports = list()
        self._audit = list()
        
        self._audit.append({
            'audit': 'file',
            'value': '/etc/sysctl.conf',
        })
        self._audit.append({
            'audit': 'process',
            'value': 'sysctl -a',
        })

        self._sysctl()

        self._parsing = Parsing(self._objects, self._audit)

    def _sysctl(self):
        self._objects['sysctl'] = sysctl()

    def runAudit(self):
        # Read /etc/sysctl.conf
        self._parsing.runParsing()
        self._reports.append(self._parsing.getResults())

        # Run process sysctl

    def getReports(self) -> list:
        return self._reports

