#!/usr/bin/env python3

import re
from subprocess import run


def identifySystem():
    os = None
    with open('/etc/issue', 'r') as f:
        line = f.readline() 
        if re.search('Arch Linux', line):
            os = 'ARCHLINUX'
        elif re.search('Ubuntu', line):
            os = 'UBUNTU'
        elif re.search('Debian', line):
            os = 'DEBIAN'
        else:
            os = 'UNKNOWN'

    return os

def getKernelVersion():
    """
        This function get the kernel version Linux
    """
    kernelVers = run(['/usr/bin/uname', '-r'])
    return kernelVers.stdout
